var fs       = require("fs");
var mustache = require("mustache");

var _template_cache = {};

// This code is from node_mailer It loads a template from a file, given by the |message|'s
// |template| property.  After the template is loaded, calls callback with the contents
// processed by Mustache.
// Object -> (Object -> undefined) -> undefined
function afterLoadingTemplate(message, callback) {
    if (_template_cache[message.template]) {
        if (_template_cache[message.template].loaded) {
            message.body = mustache.to_html(_template_cache[message.template].template, message.data);
            callback(message);
        } else {
            _template_cache[message.template].queue.push(message);
        }
    } else {
        _template_cache[message.template]          = {};
        _template_cache[message.template].loaded   = false;
        _template_cache[message.template].template = '';
        _template_cache[message.template].queue    = [];

        fs.readFile(message.template, function(err, result){
            if (err) {
                // TODO: do not ignore error
                return;
            }

            _template_cache[message.template].template = result.toString();
            _template_cache[message.template].loaded   = true;

            // "Drain" the queue
            _template_cache[message.template].queue.push(message);
            _template_cache[message.template].queue.forEach(function(msg, i){
                msg.body = mustache.to_html(_template_cache[message.template].template, msg.data);
                callback(msg);
            });

            // Clear the queue out
            _template_cache[message.template].queue = [];
        });
    }
}

module.exports = {
    afterLoadingTemplate : afterLoadingTemplate
};
